package org.omg.PortableServer;

import java.io.ObjectOutputStream;
import java.io.IOException;
import org.omg.CORBA.ORB;
import java.io.ObjectInputStream;
import org.omg.CORBA.portable.ServantObject;
import org.omg.PortableServer.ServantLocatorPackage.CookieHolder;
import org.omg.CORBA.portable.ObjectImpl;

public class _ServantLocatorStub extends ObjectImpl implements ServantLocator
{
    public static final Class _opsClass;
    private static String[] __ids;
    
    public _ServantLocatorStub() {
    }
    
    public Servant preinvoke(byte[] array, POA poa, String s, CookieHolder cookieHolder) throws ForwardRequest {
        ServantObject servant_preinvoke = this._servant_preinvoke("preinvoke", _ServantLocatorStub._opsClass);
        ServantLocatorOperations servantLocatorOperations = (ServantLocatorOperations)servant_preinvoke.servant;
        try {
            return servantLocatorOperations.preinvoke(array, poa, s, cookieHolder);
        }
        finally {
            this._servant_postinvoke(servant_preinvoke);
        }
    }
    
    public void postinvoke(byte[] array, POA poa, String s, Object o, Servant servant) {
        ServantObject servant_preinvoke = this._servant_preinvoke("postinvoke", _ServantLocatorStub._opsClass);
        ServantLocatorOperations servantLocatorOperations = (ServantLocatorOperations)servant_preinvoke.servant;
        try {
            servantLocatorOperations.postinvoke(array, poa, s, o, servant);
        }
        finally {
            this._servant_postinvoke(servant_preinvoke);
        }
    }
    
    public String[] _ids() {
        return (String[])(String[])_ServantLocatorStub.__ids.clone();
    }
    
    private void readObject(ObjectInputStream objectInputStream) throws IOException {
        String utf = objectInputStream.readUTF();
        ORB init = ORB.init(null, null);
        try {
            this._set_delegate(((ObjectImpl)init.string_to_object(utf))._get_delegate());
        }
        finally {
            init.destroy();
        }
    }
    
    private void writeObject(ObjectOutputStream objectOutputStream) throws IOException {
        ORB init = ORB.init(null, null);
        try {
            objectOutputStream.writeUTF(init.object_to_string(this));
        }
        finally {
            init.destroy();
        }
    }
    
    static {
        _opsClass = ServantLocatorOperations.class;
        _ServantLocatorStub.__ids = new String[] { "IDL:omg.org/PortableServer/ServantLocator:1.0", "IDL:omg.org/PortableServer/ServantManager:1.0" };
    }
}
